# Uses of Enum Class
org.apache.sysds.lops.MapMultChain.ChainType

Packages that use MapMultChain.ChainType
Package
Description
org.apache.sysds.hops
org.apache.sysds.lops
org.apache.sysds.runtime.compress
org.apache.sysds.runtime.compress.lib
org.apache.sysds.runtime.instructions.cp
org.apache.sysds.runtime.instructions.fed
org.apache.sysds.runtime.matrix.data

## Uses of MapMultChain.ChainType in org.apache.sysds.hops

Methods in org.apache.sysds.hops that return MapMultChain.ChainType
Modifier and Type
Method
Description
`MapMultChain.ChainType`
AggBinaryOp.`checkMapMultChain()`
MapMultChain: Determine if XtwXv/XtXv pattern applies for this aggbinary and if yes which type.

## Uses of MapMultChain.ChainType in org.apache.sysds.lops

Methods in org.apache.sysds.lops that return MapMultChain.ChainType
Modifier and Type
Method
Description
`static MapMultChain.ChainType`
MapMultChain.ChainType.`valueOf(String name)`
Returns the enum constant of this class with the specified name.
`static MapMultChain.ChainType[]`
MapMultChain.ChainType.`values()`
Returns an array containing the constants of this enum class, in the order they are declared.
Constructors in org.apache.sysds.lops with parameters of type MapMultChain.ChainType
Modifier
Constructor
Description
``
`MapMultChain(Lop input1, Lop input2, Lop input3, MapMultChain.ChainType chain, Types.DataType dt, Types.ValueType vt, Types.ExecType et)`
Constructor to setup a map mult chain with weights

## Uses of MapMultChain.ChainType in org.apache.sysds.runtime.compress

Methods in org.apache.sysds.runtime.compress with parameters of type MapMultChain.ChainType
Modifier and Type
Method
Description
`MatrixBlock`
CompressedMatrixBlock.`chainMatrixMultOperations(MatrixBlock v, MatrixBlock w, MatrixBlock out, MapMultChain.ChainType ctype, int k)`

## Uses of MapMultChain.ChainType in org.apache.sysds.runtime.compress.lib

Methods in org.apache.sysds.runtime.compress.lib with parameters of type MapMultChain.ChainType
Modifier and Type
Method
Description
`static MatrixBlock`
CLALibMMChain.`mmChain(CompressedMatrixBlock x, MatrixBlock v, MatrixBlock w, MatrixBlock out, MapMultChain.ChainType ctype, int k)`
Support compressed MM chain operation to fuse the following cases :

## Uses of MapMultChain.ChainType in org.apache.sysds.runtime.instructions.cp

Methods in org.apache.sysds.runtime.instructions.cp that return MapMultChain.ChainType
Modifier and Type
Method
Description
`MapMultChain.ChainType`
MMChainCPInstruction.`getMMChainType()`

## Uses of MapMultChain.ChainType in org.apache.sysds.runtime.instructions.fed

Methods in org.apache.sysds.runtime.instructions.fed that return MapMultChain.ChainType
Modifier and Type
Method
Description
`MapMultChain.ChainType`
MMChainFEDInstruction.`getMMChainType()`
Constructors in org.apache.sysds.runtime.instructions.fed with parameters of type MapMultChain.ChainType
Modifier
Constructor
Description
``
`MMChainFEDInstruction(CPOperand in1, CPOperand in2, CPOperand in3, CPOperand out, MapMultChain.ChainType type, int k, String opcode, String istr)`

## Uses of MapMultChain.ChainType in org.apache.sysds.runtime.matrix.data

Methods in org.apache.sysds.runtime.matrix.data with parameters of type MapMultChain.ChainType
Modifier and Type
Method
Description
`MatrixBlock`
MatrixBlock.`chainMatrixMultOperations(MatrixBlock v, MatrixBlock w, MatrixBlock out, MapMultChain.ChainType ctype)`
`MatrixBlock`
MatrixBlock.`chainMatrixMultOperations(MatrixBlock v, MatrixBlock w, MatrixBlock out, MapMultChain.ChainType ctype, int k)`
`static void`
LibMatrixMult.`matrixMultChain(MatrixBlock mX, MatrixBlock mV, MatrixBlock mW, MatrixBlock ret, MapMultChain.ChainType ct)`
Performs a matrix multiplication chain operation of type t(X)%*%(X%*%v) or t(X)%*%(w*(X%*%v)).
`static void`
LibMatrixMult.`matrixMultChain(MatrixBlock mX, MatrixBlock mV, MatrixBlock mW, MatrixBlock ret, MapMultChain.ChainType ct, int k)`
Performs a parallel matrix multiplication chain operation of type t(X)%*%(X%*%v) or t(X)%*%(w*(X%*%v)).